Ogre::GLSLLinkProgramManager Class Reference

Ogre assumes that there are separate vertex and fragment programs to deal with but GLSL has one program object that represents the active vertex and fragment shader objects during a rendering state. More...

`#include <OgreGLSLLinkProgramManager.h>`

Inheritance diagram for Ogre::GLSLLinkProgramManager:
[legend]

List of all members.

## Public Member Functions

| GLSLLinkProgramManager (void)
| ~GLSLLinkProgramManager (void)
GLSLLinkProgram * | getActiveLinkProgram (void)
| Get the program object that links the two active shader objects together if a program object was not already created and linked a new one is created and linked.
void | setActiveFragmentShader (GLSLGpuProgram *fragmentGpuProgram)
| Set the active fragment shader for the next rendering state.
void | setActiveGeometryShader (GLSLGpuProgram *geometryGpuProgram)
| Set the active geometry shader for the next rendering state.
void | setActiveVertexShader (GLSLGpuProgram *vertexGpuProgram)
| Set the active vertex shader for the next rendering state.
void | extractUniforms (GLhandleARB programObject, const GpuConstantDefinitionMap *vertexConstantDefs, const GpuConstantDefinitionMap *geometryConstantDefs, const GpuConstantDefinitionMap *fragmentConstantDefs, GLUniformReferenceList &list)
| Populate a list of uniforms based on a program object.
void | extractConstantDefs (const String &src, GpuNamedConstants &constantDefs, const String &filename)
| Populate a list of uniforms based on GLSL source.

## Static Public Member Functions

static GLSLLinkProgramManager & | getSingleton (void)
static GLSLLinkProgramManager * | getSingletonPtr (void)

## Static Protected Attributes

static GLSLLinkProgramManager * | msSingleton

## Private Types

typedef map< uint64, GLSLLinkProgram * >::type | LinkProgramMap
typedef LinkProgramMap::iterator | LinkProgramIterator
typedef map< String, GLenum >::type | StringToEnumMap

## Private Member Functions

void | completeDefInfo (GLenum gltype, GpuConstantDefinition &defToUpdate)
| Use type to complete other information.
bool | completeParamSource (const String &paramName, const GpuConstantDefinitionMap *vertexConstantDefs, const GpuConstantDefinitionMap *geometryConstantDefs, const GpuConstantDefinitionMap *fragmentConstantDefs, GLUniformReference &refToUpdate)
| Find where the data for a specific uniform should come from, populate.

## Private Attributes

LinkProgramMap | mLinkPrograms
| container holding previously created program objects
GLSLGpuProgram * | mActiveVertexGpuProgram
| active objects defining the active rendering gpu state
GLSLGpuProgram * | mActiveGeometryGpuProgram
GLSLGpuProgram * | mActiveFragmentGpuProgram
GLSLLinkProgram * | mActiveLinkProgram
StringToEnumMap | mTypeEnumMap

## Detailed Description

Ogre assumes that there are separate vertex and fragment programs to deal with but GLSL has one program object that represents the active vertex and fragment shader objects during a rendering state.

GLSL Vertex and fragment shader objects are compiled separately and then attached to a program object and then the program object is linked. Since Ogre can only handle one vertex program and one fragment program being active in a pass, the GLSL Link Program Manager does the same. The GLSL Link program manager acts as a state machine and activates a program object based on the active vertex and fragment program. Previously created program objects are stored along with a unique key in a hash_map for quick retrieval the next time the program object is required.

Definition at line 52 of file OgreGLSLLinkProgramManager.h.

## Member Typedef Documentation

typedef LinkProgramMap::iterator Ogre::GLSLLinkProgramManager::LinkProgramIterator`[private]`

Definition at line 58 of file OgreGLSLLinkProgramManager.h.

typedef map<uint64, GLSLLinkProgram*>::type Ogre::GLSLLinkProgramManager::LinkProgramMap`[private]`

Definition at line 57 of file OgreGLSLLinkProgramManager.h.

typedef map<String, GLenum>::type Ogre::GLSLLinkProgramManager::StringToEnumMap`[private]`

Definition at line 69 of file OgreGLSLLinkProgramManager.h.

## Constructor & Destructor Documentation

Ogre::GLSLLinkProgramManager::GLSLLinkProgramManager | ( | void |  | ) |

Ogre::GLSLLinkProgramManager::~GLSLLinkProgramManager | ( | void |  | ) |

## Member Function Documentation

void Ogre::GLSLLinkProgramManager::completeDefInfo | ( | GLenum | gltype,
|  | GpuConstantDefinition & | defToUpdate
| ) |  | `[private]`

Use type to complete other information.

bool Ogre::GLSLLinkProgramManager::completeParamSource | ( | const String & | paramName,
|  | const GpuConstantDefinitionMap * | vertexConstantDefs,
|  | const GpuConstantDefinitionMap * | geometryConstantDefs,
|  | const GpuConstantDefinitionMap * | fragmentConstantDefs,
|  | GLUniformReference & | refToUpdate
| ) |  | `[private]`

Find where the data for a specific uniform should come from, populate.

void Ogre::GLSLLinkProgramManager::extractConstantDefs | ( | const String & | src,
|  | GpuNamedConstants & | constantDefs,
|  | const String & | filename
| ) |  |

Populate a list of uniforms based on GLSL source.

Parameters:

  src | Reference to the source code
  list | The defs to populate (will not be cleared before adding, clear it yourself before calling this if that's what you want).
  filename | The file name this came from, for logging errors.

void Ogre::GLSLLinkProgramManager::extractUniforms | ( | GLhandleARB | programObject,
|  | const GpuConstantDefinitionMap * | vertexConstantDefs,
|  | const GpuConstantDefinitionMap * | geometryConstantDefs,
|  | const GpuConstantDefinitionMap * | fragmentConstantDefs,
|  | GLUniformReferenceList & | list
| ) |  |

Populate a list of uniforms based on a program object.

Parameters:

  programObject | Handle to the program object to query
  vertexConstantDefs | Definition of the constants extracted from the vertex program, used to match up physical buffer indexes with program uniforms. May be null if there is no vertex program.
  geometryConstantDefs | Definition of the constants extracted from the geometry program, used to match up physical buffer indexes with program uniforms. May be null if there is no geometry program.
  fragmentConstantDefs | Definition of the constants extracted from the fragment program, used to match up physical buffer indexes with program uniforms. May be null if there is no fragment program.
  list | The list to populate (will not be cleared before adding, clear it yourself before calling this if that's what you want).

GLSLLinkProgram* Ogre::GLSLLinkProgramManager::getActiveLinkProgram | ( | void |  | ) |

Get the program object that links the two active shader objects together if a program object was not already created and linked a new one is created and linked.

static GLSLLinkProgramManager& Ogre::GLSLLinkProgramManager::getSingleton | ( | void |  | ) | `[static]`

Reimplemented from Ogre::Singleton< GLSLLinkProgramManager >.

static GLSLLinkProgramManager* Ogre::GLSLLinkProgramManager::getSingletonPtr | ( | void |  | ) | `[static]`

Reimplemented from Ogre::Singleton< GLSLLinkProgramManager >.

void Ogre::GLSLLinkProgramManager::setActiveFragmentShader | ( | GLSLGpuProgram * | fragmentGpuProgram | ) |

Set the active fragment shader for the next rendering state.

The active program object will be cleared. Normally called from the GLSLGpuProgram::bindProgram and unbindProgram methods

void Ogre::GLSLLinkProgramManager::setActiveGeometryShader | ( | GLSLGpuProgram * | geometryGpuProgram | ) |

Set the active geometry shader for the next rendering state.

The active program object will be cleared. Normally called from the GLSLGpuProgram::bindProgram and unbindProgram methods

void Ogre::GLSLLinkProgramManager::setActiveVertexShader | ( | GLSLGpuProgram * | vertexGpuProgram | ) |

Set the active vertex shader for the next rendering state.

The active program object will be cleared. Normally called from the GLSLGpuProgram::bindProgram and unbindProgram methods

## Member Data Documentation

GLSLGpuProgram* Ogre::GLSLLinkProgramManager::mActiveFragmentGpuProgram`[private]`

Definition at line 66 of file OgreGLSLLinkProgramManager.h.

GLSLGpuProgram* Ogre::GLSLLinkProgramManager::mActiveGeometryGpuProgram`[private]`

Definition at line 65 of file OgreGLSLLinkProgramManager.h.

GLSLLinkProgram* Ogre::GLSLLinkProgramManager::mActiveLinkProgram`[private]`

Definition at line 67 of file OgreGLSLLinkProgramManager.h.

GLSLGpuProgram* Ogre::GLSLLinkProgramManager::mActiveVertexGpuProgram`[private]`

active objects defining the active rendering gpu state

Definition at line 64 of file OgreGLSLLinkProgramManager.h.

LinkProgramMap Ogre::GLSLLinkProgramManager::mLinkPrograms`[private]`

container holding previously created program objects

Definition at line 61 of file OgreGLSLLinkProgramManager.h.

GLSLLinkProgramManager * Ogre::Singleton< GLSLLinkProgramManager >::msSingleton`[static, protected, inherited]`

Definition at line 75 of file OgreSingleton.h.

StringToEnumMap Ogre::GLSLLinkProgramManager::mTypeEnumMap`[private]`

Definition at line 70 of file OgreGLSLLinkProgramManager.h.

The documentation for this class was generated from the following file:

- OgreGLSLLinkProgramManager.h

Copyright © 2012 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Sun Sep 2 2012 07:27:55